% Copyright © 2017 Universitat Jaume I (UJI) and Tampere University of Technology (TUT)
%
% Permission is hereby granted, free of charge, to any person obtaining a copy of
% this software and associated documentation files (the "Software"), to deal in
% the Software without restriction, including without limitation the rights to
% use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
% of the Software, and to permit persons to whom the Software is furnished to do
% so, subject to the following conditions:
%
% The above copyright notice and this permission notice shall be included in all
% copies or substantial portions of the Software.
%
% THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
% IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
% FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
% AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
% LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
% OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
% SOFTWARE.

function figure12(IS_OCTAVE)
% figure12 Draws and saves in './figures' folder Figure 12 presented in paper.
%
%
%   IS_OCTAVE: 0 -> matlab, 1 -> octave

    close all;
    
    if ~exist('./figures','dir')
        mkdir('./figures');
    end

	%pkg load statistics

	%%% FIGURE 12


	box1 = {};
	databasename = 'mandb_reduced';
	method       = 'remove_antenna';
	message      = 'AP artificially disconnected';
	macs         = 11;

	load(['results_' databasename '_k_001/normal/resume.mat']);
	[repetitions, testsamples] = size(distances_accum);
	antennas                   = 11;
	zones                      = max(max(cell2mat(area_estm_accum)));

	for i = 1:antennas error_test{i} = []; error_estm{i} = []; end

	i=0;
	error = [distance_accum(1:repetitions), accuracy_accum(1:repetitions), 0*ones(repetitions,1)];
	i=i+1; box1{i} = distance_accum(1:repetitions)'; box2{i} = accuracy_accum(1:repetitions)';
	%area_test{i} = []; 
  area_estm{i} = [];
	for j=1:repetitions;
	  %area_test{i} = [area_test{i};area_test_accum{j}];
    area_estm{i} = [area_estm{i};area_estm_accum{j}];
	  for k = 1:antennas
	  if  sum(area_estm_accum{j}(:,1)==k)
	  error_tmp = [sum(distances_accum(j,  area_estm_accum{j}(:,1)==k))./sum(area_estm_accum{j}(:,1)==k),...
				   sum(accuracies_accum(j, area_estm_accum{j}(:,1)==k))./sum(area_estm_accum{j}(:,1)==k),...
				   0];
					 error_estm{k}     = [error_estm{k};error_tmp];
	  box1_estm{i,k}(j) = sum(distances_accum(j,  area_estm_accum{j}(:,1)==k))./sum(area_estm_accum{j}(:,1)==k);
	  box2_estm{i,k}(j) = sum(accuracies_accum(j, area_estm_accum{j}(:,1)==k))./sum(area_estm_accum{j}(:,1)==k);
	  %box1_test{i,k}(j) = sum(distances_accum(j,  area_test_accum{j}(:,1)==k))./sum(area_test_accum{j}(:,1)==k);
	  %box2_test{i,k}(j) = sum(accuracies_accum(j, area_test_accum{j}(:,1)==k))./sum(area_test_accum{j}(:,1)==k);
	  else
		 error_tmp=  [-1,-1,0];
		   error_estm{k}     = [error_estm{k};error_tmp];
		box1_estm{i,k}(j) = nan;
		box2_estm{i,k}(j) = nan;
		%box1_test{i,k}(j) = nan;
		%box2_test{i,k}(j) = nan;
	  end
	  if  sum(area_test_accum{j}==k)
	  error_tmp = [sum(distances_accum(j,  area_test_accum{j}==k))./sum(area_test_accum{j}==k),...
				   sum(accuracies_accum(j, area_test_accum{j}==k))./sum(area_test_accum{j}==k),...
				   0];
	  else
		 error_tmp = [-1,-1,0];
	  end
	  error_test{k}     = [error_test{k};error_tmp];
	  end
	end

	for rep = 1:antennas

	  % rep

	  % i
		load(['results_' databasename '_k_001/' method int2str(rep) '/resume.mat'])
		error = [error;[distance_accum(1:repetitions), accuracy_accum(1:repetitions), rep*ones(repetitions,1)]];

		i=i+1; box1{i} = distance_accum(1:repetitions)'; box2{i} = accuracy_accum(1:repetitions)';
		%area_test{i} = []; 
    area_estm{i} = [];
		for j=1:repetitions;
		%area_test{i} = [area_test{i};area_test_accum{j}];
    area_estm{i} = [area_estm{i};area_estm_accum{j}];

		for k = 1:zones
		if  sum(area_estm_accum{j}(:,1)==k)
				error_tmp = [sum(distances_accum(j,  area_estm_accum{j}(:,1)==k))./sum(area_estm_accum{j}(:,1)==k),...
					 sum(accuracies_accum(j, area_estm_accum{j}(:,1)==k))./sum(area_estm_accum{j}(:,1)==k),...
					 rep];
				 error_estm{k}     = [error_estm{k};error_tmp];
				 box1_estm{i,k}(j) = sum(distances_accum(j,  area_estm_accum{j}(:,1)==k))./sum(area_estm_accum{j}(:,1)==k);
				  box2_estm{i,k}(j) = sum(accuracies_accum(j, area_estm_accum{j}(:,1)==k))./sum(area_estm_accum{j}(:,1)==k);
				  %box1_test{i,k}(j) = sum(distances_accum(j,  area_test_accum{j}(:,1)==k))./sum(area_test_accum{j}(:,1)==k);
				  %box2_test{i,k}(j) = sum(accuracies_accum(j, area_test_accum{j}(:,1)==k))./sum(area_test_accum{j}(:,1)==k);
		else
		   error_tmp = [-1,-1,0];
			   error_estm{k}     = [error_estm{k};error_tmp];
		box1_estm{i,k}(j) = nan;
		box2_estm{i,k}(j) = nan;
		%box1_test{i,k}(j) = nan;
		%box2_test{i,k}(j) = nan;

		end
	%    error_estm{k}     = [error_estm{k};error_tmp];
		%box1_estm{i,k}(j) = sum(distances_accum(j,  area_estm_accum{j}==k))./sum(area_estm_accum{j}==k);
	%    %box2_estm{i,k}(j) = sum(accuracies_accum(j, area_estm_accum{j}==k))./sum(area_estm_accum{j}==k);
	%    box1_test{i,k}(j) = sum(distances_accum(j,  area_test_accum{j}==k))./sum(area_test_accum{j}==k);
	%    box2_test{i,k}(j) = sum(accuracies_accum(j, area_test_accum{j}==k))./sum(area_test_accum{j}==k);
		if  sum(area_test_accum{j}==k)
		error_tmp = [sum(distances_accum(j,  area_test_accum{j}==k))./sum(area_test_accum{j}==k),...
					 sum(accuracies_accum(j, area_test_accum{j}==k))./sum(area_test_accum{j}==k),...
					 rep];
		else
		   error_tmp = [-1,-1,0];
		end
		error_test{k}     = [error_test{k};error_tmp];
		end
		end
	end

	graphics_dir = [''];

	myxticklabels{1} = {'None'};
	for i = 1:macs
	  if strcmp(method,'remove_antenna')
		myxticklabels{i+1} = ['AP#' sprintf('%02d',i)];
	  else
		myxticklabels{i+1} = [sprintf('%02d',i) 'APs'];
	  end
	end

	sufix = 'ABCDEFGHIJ';
	for k = 1:10
		myplot = boxplot(cell2mat({box1_estm{:,k}}')');
		if IS_OCTAVE
			set(gca,'xtick',[1:2:(macs+1)],'xticklabel',(myxticklabels(1:2:end)));
		else
			set(gca,'xtick',[1:2:(macs+1)],'xticklabel',string(myxticklabels(1:2:end)));
		end
		set(gca,'xlim',[0 (macs+2)]);
		%title (['Mannheim - Zone ' sprintf('%02d',k+1*(k>=7))]);
		%title(['Effect of disconnecting APs in the RSS distance (Area ' int2str(k) ')']);
		xlabel(message,'fontsize', 14); my_ylim = ylim; my_xlim = xlim;
		ylabel('Average distance to the most similar ref. fingerprint (dBm)','fontsize', 14);
		set(gca, 'fontsize', 14);

		my_ylim = ylim; my_xlim = xlim;
		daspect([ 1/(my_ylim(2)-my_ylim(1)) 1/(my_xlim(2)-my_xlim(1)) 1]);
		print([ graphics_dir 'figures/figure12' sufix(k)],'-dpdf');
		print([ graphics_dir 'figures/figure12' sufix(k)],'-dpng');
	end

end

