% Copyright © 2017 Universitat Jaume I (UJI) and Tampere University of Technology (TUT)
%
% Permission is hereby granted, free of charge, to any person obtaining a copy of
% this software and associated documentation files (the "Software"), to deal in
% the Software without restriction, including without limitation the rights to
% use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
% of the Software, and to permit persons to whom the Software is furnished to do
% so, subject to the following conditions:
%
% The above copyright notice and this permission notice shall be included in all
% copies or substantial portions of the Software.
%
% THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
% IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
% FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
% AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
% LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
% OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
% SOFTWARE.

function figure13(IS_OCTAVE)
% figure13 Draws and saves in './figures' folder Figure 13 presented in paper.
%
%
%   IS_OCTAVE: 0 -> matlab, 1 -> octave

	close all;
	

    if ~exist('./figures','dir')
        mkdir('./figures');
    end


	%%% FIGURE 13
	normalvscambio = [];
	normalvscambio2 = [];
	normalvscambio3 = [];

	databasename = 'simdb';
	close all;
	%figure; hold on;
	load(['results_' databasename '_k_001/normal/resume.mat']);
	%scatter(accuracy_accum(1:100),distance_accum(1:100),40,0,'o');
	aaccum_nominal = accuracy_accum;
	daccum_nominal = distance_accum;
	mean(aaccum_nominal);
	mean(daccum_nominal);
	aaccum_norm = accuracy_accum./accuracy_accum;
	daccum_norm = distance_accum./distance_accum;
	aaccum = accuracy_accum; mina1 = (aaccum(1));%mina1 = mean(aaccum);
	daccum = distance_accum; mind1 = (daccum(1));%mind1 = mean(daccum);
	normal  = distance_accum;

	for i = 1:8
		load(['results_' databasename '_k_001/remove_antennas_random_' int2str(i) '/resume.mat']);
		%scatter(accuracy_accum(1:100),distance_accum(1:100),40,i,'x');
		aaccum = [aaccum;accuracy_accum];
		daccum = [daccum;distance_accum];
		aaccum_norm = [aaccum_norm;accuracy_accum./aaccum_nominal];
		daccum_norm = [daccum_norm;distance_accum./daccum_nominal];
		normalvscambio = [normalvscambio;[normal,distance_accum]];
	end
	for i = 2:8
		load(['results_' databasename '_k_001/switch_antennas_random_' int2str(i) '/resume.mat']);
		%scatter(accuracy_accum(1:100),distance_accum(1:100),40,i,'+');
		aaccum = [aaccum;accuracy_accum];
		daccum = [daccum;distance_accum];
		aaccum_norm = [aaccum_norm;accuracy_accum./aaccum_nominal];
		daccum_norm = [daccum_norm;distance_accum./daccum_nominal];
		normalvscambio = [normalvscambio;[normal,distance_accum]];
	end



	databasename = 'libdb_13_2';
	macconf      = 0;
	close all;
	%figure; hold on;
	load(['results_' databasename '_k_001/normal/resume.mat']);
	%scatter(accuracy_accum(1:60),distance_accum(1:60),40,0,'o')
	scatter(0,0,1,0,'.');
	%aaccum2 = accuracy_accum; mina2 = mean(aaccum2);
	%daccum2 = distance_accum; mind2 = mean(daccum2);
	aaccum_nominal = accuracy_accum;
	daccum_nominal = distance_accum;
	mean(aaccum_nominal);
	mean(daccum_nominal);
	aaccum2_norm = accuracy_accum./accuracy_accum;
	daccum2_norm = distance_accum./distance_accum;
	aaccum2 = accuracy_accum; mina2 = (aaccum2(1));%mina1 = mean(aaccum);
	daccum2 = distance_accum; mind2 = (daccum2(1));%mind1 = mean(daccum);
	normal2  = distance_accum;
	for i = 1:13
		load(['results_' databasename '_k_001/remove_antennas_random_' int2str(i) '/resume.mat']);
		%scatter(accuracy_accum(1:60),distance_accum(1:60),40,i,'x');
		aaccum2 = [aaccum2;accuracy_accum];
		daccum2 = [daccum2;distance_accum];
		aaccum2_norm = [aaccum2_norm;accuracy_accum./aaccum_nominal];
		daccum2_norm = [daccum2_norm;distance_accum./daccum_nominal];
		normalvscambio2 = [normalvscambio2;[normal2,distance_accum]];

	end
	for i = 2:13
		load(['results_' databasename '_k_001/switch_antennas_random_' int2str(i) '/resume.mat']);
		%scatter(accuracy_accum(1:60),distance_accum(1:60),40,i,'+');
		aaccum2 = [aaccum2;accuracy_accum];
		daccum2 = [daccum2;distance_accum];
		aaccum2_norm = [aaccum2_norm;accuracy_accum./aaccum_nominal];
		daccum2_norm = [daccum2_norm;distance_accum./daccum_nominal];
		normalvscambio2 = [normalvscambio2;[normal2,distance_accum]];
	end


	databasename = 'mandb_reduced';
	close all;
	%figure; hold on;
	scatter(0,0,1,0,'.');
	load(['results_' databasename '_k_001/normal/resume.mat']);
	%scatter(accuracy_accum(1:110),distance_accum(1:110),40,0,'o');
	aaccum_nominal = accuracy_accum;
	daccum_nominal = distance_accum;
	mean(aaccum_nominal);
	mean(daccum_nominal);
	aaccum3_norm = accuracy_accum./accuracy_accum;
	daccum3_norm = distance_accum./distance_accum;
	aaccum3 = accuracy_accum; mina3 = (aaccum3(1));%mina1 = mean(aaccum);
	daccum3 = distance_accum; mind3 = (daccum3(1));%mind1 = mean(daccum);
	normal3  = distance_accum;
	for i = 1:11
		load(['results_' databasename '_k_001/remove_antennas_random_' int2str(i) '/resume.mat']);
		%scatter(accuracy_accum(1:110),distance_accum(1:110),40,i,'x');
		aaccum3 = [aaccum3;accuracy_accum];
		daccum3 = [daccum3;distance_accum];
		aaccum3_norm = [aaccum3_norm;accuracy_accum./aaccum_nominal];
		daccum3_norm = [daccum3_norm;distance_accum./daccum_nominal];
		normalvscambio3 = [normalvscambio3;[normal3,distance_accum]];
	end
	for i = 2:11
		load(['results_' databasename '_k_001/switch_antennas_random_' int2str(i) '/resume.mat']);
		%scatter(accuracy_accum(1:110),distance_accum(1:110),40,i,'+');
		aaccum3 = [aaccum3;accuracy_accum];
		daccum3 = [daccum3;distance_accum];
		aaccum3_norm = [aaccum3_norm;accuracy_accum./aaccum_nominal];
		daccum3_norm = [daccum3_norm;distance_accum./daccum_nominal];
		normalvscambio3 = [normalvscambio3;[normal3,distance_accum]];
	end





	close all
	aaccum0 = [aaccum2_norm;aaccum3_norm];
	daccum0 = [daccum2_norm;daccum3_norm];
	
	if(IS_OCTAVE)
        [a,b]   = corrcoef(aaccum0,daccum0); hold on
        [a2,b2] = corrcoef(aaccum0,daccum0,'Spearman');
    else
        [a,b]   = corr(aaccum0,daccum0,'type','Pearson');
        [a2,b2] = corr(aaccum0,daccum0,'type','Spearman');
    end
    hold on;
	
	scatter(daccum0,aaccum0,20,'x');
	daspect([1/20 1/10 1]);
	ylabel('Relative Averaged Accuracy (times nominal case)');
	xlabel('Relative Averaged Distance RSS (times nominal case)');
	text(2.5,0.65,['Pearson''s Corr. Coef.: ' sprintf('%0.2f',a) ', p-value: ' sprintf('%0.2f',b)]);
	text(2.5,0.35,['Spearman''s Corr. Coef.: ' sprintf('%0.2f',a2) ', p-value: ' sprintf('%0.2f',b2)]);

	myxmax = 6;
	myymax = 12;
	xlim([0,myxmax]);
	ylim([0,myymax]);


	x = daccum0;
	y = aaccum0;

	if IS_OCTAVE
		n = size(daccum0,1);
		F = [ones(n,1),x(:)];

		[p,e_var,r,p_var,y_var] = LinearRegression(F,y);
		yFit = F*p;


		m=(max(sort(yFit))-min(sort(yFit)))/(max(sort(x))-min(sort(x)));hold on;
		%plot(x,yFit,'-g',x,yFit+1.96*sqrt(y_var),'--r',x,yFit-1.96*sqrt(y_var),'--r')
		plot(0:1:myxmax,([0:1:myxmax]-min(x))*m+min(yFit),'g-');
		plot(0:1:myxmax,([0:1:myxmax]-min(x))*m+min(yFit)+1*sqrt(mean((y_var))),'r--');
		plot(0:1:myxmax,([0:1:myxmax]-min(x))*m+min(yFit)-1*sqrt(mean((y_var))),'r--');
	else

		p1 = polyfit(x,y,1);
		f = polyval(p1,x);
        mu = std(f-y);

		reproduce = 0:0.01:myxmax;
		plot(reproduce, p1(1)*(reproduce.^1)+p1(2),'g-');
        plot(reproduce, p1(1)*(reproduce.^1)+p1(2)+mu,'r--');
        plot(reproduce, p1(1)*(reproduce.^1)+p1(2)-mu,'r--');

	end

	print(['figures/figure13.pdf'],'-dpdf');
	print(['figures/figure13.png'],'-dpng');


	%[p, s, mu] = polyfit (x, y, 2)
	%
	%vectorx = 0:0.01:myxmax;
	%plot(vectorx,p(1)*vectorx.^2+p(2)*vectorx.^1+p(3));

end
