% Copyright © 2017 Universitat Jaume I (UJI) and Tampere University of Technology (TUT)
%
% Permission is hereby granted, free of charge, to any person obtaining a copy of
% this software and associated documentation files (the "Software"), to deal in
% the Software without restriction, including without limitation the rights to
% use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
% of the Software, and to permit persons to whom the Software is furnished to do
% so, subject to the following conditions:
%
% The above copyright notice and this permission notice shall be included in all
% copies or substantial portions of the Software.
%
% THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
% IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
% FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
% AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
% LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
% OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
% SOFTWARE.

function generateDB_simdb(IS_OCTAVE)
% generateDB_simdb Creates '\databases_singlefile\simdb.mat' with 100 
% simulated databased that were previously generated and stored.
%
%
%   IS_OCTAVE: 0 -> matlab, 1 -> octave

    if ~exist('databases_singlefile','dir')
        mkdir('databases_singlefile');
    end


    for i = 1:100

      database.trainingMacs  = csvread(['../databases/simdb_files/trn' sprintf('%03d',i) 'rss.csv']);
      database.trainingLabels= csvread(['../databases/simdb_files/trn' sprintf('%03d',i) 'crd.csv'  ]);
      database.testMacs      = csvread(['../databases/simdb_files/tst' sprintf('%03d',i) 'rss.csv'  ]);
      database.testLabels    = csvread(['../databases/simdb_files/tst' sprintf('%03d',i) 'crd.csv'  ]);

      database.trainingMacs  = database.trainingMacs(:,1:8);
      database.testMacs      = database.testMacs(:,1:8);

      databases{i} = database;

      clear database; 

    end

    if IS_OCTAVE
        save(['databases_singlefile/simdb.mat'],'databases','-mat7-binary');
    else
        save(['databases_singlefile/simdb.mat'],'databases');
    end
	
	disp('Generation done for .\databases_singlefile\simdb.mat');
end