% Copyright  2017 Universitat Jaume I (UJI) and Tampere University of Technology (TUT)
%
% Permission is hereby granted, free of charge, to any person obtaining a copy of
% this software and associated documentation files (the "Software"), to deal in
% the Software without restriction, including without limitation the rights to
% use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
% of the Software, and to permit persons to whom the Software is furnished to do
% so, subject to the following conditions:
%
% The above copyright notice and this permission notice shall be included in all
% copies or substantial portions of the Software.
%
% THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
% IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
% FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
% AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
% LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
% OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
% SOFTWARE.

function [apData] = getAPLibDataInfo()
%getAPLibDataInfo Returns the information needed for identifying the 52 known 
% APs in the Library Database.
%   The columns are: 
%   1: Original AP (column number in the Library Database).
%   2: AP Network SSID: 0 - eduroam, 1  UJI
%   3: Network broadcasting frequency.
%   4: Physical device that emitted them (to form groups).
%   5: Whether they are close (1) or not (0) to the collection area, 

apData = [
        1,0,2437,3,0
        2,0,5220,7,1
        3,0,2412,7,1
        4,0,2462,13,0
        5,0,2437,2,0
        6,1,2437,3,0
        7,1,2412,7,1
        8,1,2462,13,0
        9,1,5220,7,1
        10,1,2437,2,0
        11,0,2462,8,2
        12,1,2462,8,2
        13,0,5260,2,0
        14,1,5260,2,0
        15,0,2462,6,3
        17,1,2462,6,3
        18,0,5520,10,0
        19,0,5300,8,2
        20,0,2462,10,0
        21,1,5520,10,0
        22,1,5300,8,2
        23,1,2462,10,0
        25,0,5260,13,0
        26,0,2462,4,0
        27,0,2437,1,0
        28,1,5260,13,0
        29,1,2462,4,0
        30,1,2437,1,0
        33,1,2437,11,0
        34,0,2437,11,0
        41,1,5180,11,0
        42,0,5180,11,0
        44,0,5320,4,0
        46,1,5320,4,0
        47,1,2412,12,0
        48,0,2412,12,0
        49,0,5320,9,4
        50,1,5320,12,0
        51,1,5320,9,4
        52,1,2412,9,4
        53,0,5320,12,0
        54,0,2412,9,4
        63,0,5680,3,0
        64,1,5680,3,0
        68,1,2412,5,0
        69,0,5240,6,3
        70,0,2412,5,0
        71,1,5240,6,3
        98,0,5500,1,0
        99,1,5500,1,0
        127,1,5300,5,0
        138,0,5300,5,0
    ];
end

