% Copyright © 2017 Universitat Jaume I (UJI) and Tampere University of Technology (TUT)
%
% Permission is hereby granted, free of charge, to any person obtaining a copy of
% this software and associated documentation files (the "Software"), to deal in
% the Software without restriction, including without limitation the rights to
% use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
% of the Software, and to permit persons to whom the Software is furnished to do
% so, subject to the following conditions:
%
% The above copyright notice and this permission notice shall be included in all
% copies or substantial portions of the Software.
%
% THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
% IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
% FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
% AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
% LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
% OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
% SOFTWARE.

function [database] = loadDB( databasename , instance)
% loadDB Loads the specified database.
%
%   databasename: One of 'simdb','libdb_52','libdb_26','libdb_13_2','libdb_13_5',
%   'mandb','mandb_reduced'
%   instance:	1 to 60 for 'libdb_52','libdb_26','libdb_13_2','libdb_13_5'
%   			1 to 100 for 'simdb'
%   			1 to 110 for 'mandb','mandb_reduced'

	if strcmp(databasename,'simdb')
		database = loadDB_simdb(instance);
	elseif  strcmp(databasename,'libdb_52')
		database = loadDB_libdb_52(instance);
	elseif  strcmp(databasename,'libdb_26')
		database = loadDB_libdb_26(instance);
	elseif  strcmp(databasename,'libdb_13_2')
		database = loadDB_libdb_13_2(instance);		
	elseif  strcmp(databasename,'libdb_13_5')
		database = loadDB_libdb_13_5(instance);		
	elseif  strcmp(databasename,'mandb')
		database = loadDB_mandb(instance);
	elseif  strcmp(databasename,'mandb_reduced')
		database = loadDB_mandb_reduced(instance);
	else
		warning('The database does not exist');
	end
end

