% Copyright © 2017 Universitat Jaume I (UJI) and Tampere University of Technology (TUT)
%
% Permission is hereby granted, free of charge, to any person obtaining a copy of
% this software and associated documentation files (the "Software"), to deal in
% the Software without restriction, including without limitation the rights to
% use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
% of the Software, and to permit persons to whom the Software is furnished to do
% so, subject to the following conditions:
%
% The above copyright notice and this permission notice shall be included in all
% copies or substantial portions of the Software.
%
% THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
% IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
% FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
% AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
% LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
% OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
% SOFTWARE.

function [ database ] = loadDB_libdb_13_5( instance )

if ~(exist('databases_singlefile/libdb_13_5.mat','file'))
	
	month  = floor( (instance-1) / 6) + 1;
	subset =  mod(instance-1,6)  +1;
    
	apdata = getAPLibDataInfo();


	basefolder = '../databases/libdb_files';
	folder = [basefolder '/' sprintf('%02d',month) '/'];
		
	train_labels = load([folder 'trn01crd.csv']);
	test1_labels = load([folder 'tst01crd.csv']);
	test2_labels = load([folder 'tst02crd.csv']);
	test3_labels = load([folder 'tst03crd.csv']);
	test4_labels = load([folder 'tst04crd.csv']);
	test5_labels = load([folder 'tst05crd.csv']);	
		
	train_rss0 = load([folder 'trn01rss.csv']);
	test1_rss = load([folder 'tst01rss.csv']);
	test2_rss = load([folder 'tst02rss.csv']);
	test3_rss = load([folder 'tst03rss.csv']);
	test4_rss = load([folder 'tst04rss.csv']);
	test5_rss = load([folder 'tst05rss.csv']);	
		
	test_labels = [test1_labels;test2_labels;test3_labels;test4_labels;test5_labels;];
	test_rss0 = [test1_rss;test2_rss;test3_rss;test4_rss;test5_rss;];
		
	train_rss = zeros(size(train_rss0,1),13);
    test_rss  = zeros(size(test_rss0,1),13);
	for antenna = 1:13
  
		idx  =     apdata( ((apdata(:,4)==antenna).*(apdata(:,3)>3000))>0 ,1);  
		for i = 1:size(train_rss0,1)
		   if (train_rss0(i,idx(1))==100)&&(train_rss0(i,idx(2))==100)
			  train_rss(i,antenna) = 100;
		   elseif (train_rss0(i,idx(1))<100)&&(train_rss0(i,idx(2))==100)
			  train_rss(i,antenna) = train_rss0(i,idx(1));
		   elseif (train_rss0(i,idx(1))==100)&&(train_rss0(i,idx(2))<100)
			  train_rss(i,antenna) = train_rss0(i,idx(2));
		   else
			   train_rss(i,antenna) = mean(train_rss0(i,idx(:)));       
		   end
		end
		for i = 1:size(test_rss0,1)
		   if (test_rss0(i,idx(1))==100)&&(test_rss0(i,idx(2))==100)
			  test_rss(i,antenna) = 100;
		   elseif (test_rss0(i,idx(1))<100)&&(test_rss0(i,idx(2))==100)
			  test_rss(i,antenna) = test_rss0(i,idx(1));
		   elseif (test_rss0(i,idx(1))==100)&&(test_rss0(i,idx(2))<100)
			  test_rss(i,antenna) = test_rss0(i,idx(2));
		   else
			   test_rss(i,antenna) = mean(test_rss0(i,idx(:)));       
		   end
		end
    
	end
	   
	database.trainingMacs   = train_rss;
	database.trainingLabels = train_labels;
	database.testMacs       = test_rss(subset:6:end,:);
	database.testLabels     = test_labels(subset:6:end,:);
		
	database.trainingLabels(:,4) = database.trainingLabels(:,3);
	database.testLabels(:,4)     = database.testLabels(:,3);
		
	database.trainingLabels(:,5) = 0;
	database.testLabels(:,5)     = 0;
		
	database.trainingLabels(:,3) = 3.7*3+(database.trainingLabels(:,4)-3)*3.7/2;
	database.testLabels(:,3)     = 3.7*3+(database.testLabels(:,4)-3)*3.7/2;
  
	else
		load('databases_singlefile/libdb_13_5.mat','databases');
		database = databases{instance};
	end

end