% Copyright © 2017 Universitat Jaume I (UJI) and Tampere University of Technology (TUT)
%
% Permission is hereby granted, free of charge, to any person obtaining a copy of
% this software and associated documentation files (the "Software"), to deal in
% the Software without restriction, including without limitation the rights to
% use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
% of the Software, and to permit persons to whom the Software is furnished to do
% so, subject to the following conditions:
%
% The above copyright notice and this permission notice shall be included in all
% copies or substantial portions of the Software.
%
% THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
% IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
% FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
% AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
% LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
% OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
% SOFTWARE.

function [fp,labels,others] = loadDB_mandb_generateMatrixes (filename, macs)

	fid          = fopen (filename);
	num_of_lines = 0;
	while ~feof(fid) % counting newline character
		num_of_lines = num_of_lines + sum( fread( fid, 16384, 'char' ) == char(10) );
	end
	fclose(fid);

	fid          = fopen (filename);
	contents     = {};

	j = 0;
	k = 0;

	fp     = 100 + zeros(num_of_lines,numel(fieldnames(macs)));
	labels = zeros(num_of_lines,4);
	others = zeros(num_of_lines,1);

	for i=1:num_of_lines
	  
	  fpline =  fgets (fid);
	  if size(fpline,2)>0 && (fpline(1)~='#')
		
		j = j+1;
		
		contentsRaw{j} = fpline;    
		
		l = 0;
		fpelements = strsplit(fpline,';');
		for idx = 1:size(fpelements,2)
		  fpelement = fpelements{idx};
		  if strfind(fpelement,'t=')
			others(j,1) = str2num(fpelement(3:end));  
		  elseif strfind(fpelement,'pos=')
			pos = strsplit(fpelement(5:end),','); 
			labels(j,1) = str2num(pos{1}); 
			labels(j,2) = str2num(pos{2}); 
			labels(j,3) = str2num(pos{3});         
		  elseif strfind(fpelement,'degree=')
			labels(j,4) = str2num(fpelement(8:end));            
		  elseif strfind(fpelement,'id=')
			%others(j,2) = str2num(fpelement(4:end));        
		  else
	 
			rssVec =  strsplit(fpelement(19:end),',');
			fp(j,macs.(['MAC' strrep(fpelement(1:17),':','')])) = str2num(rssVec{1});

			
		  end
		end
		
	  end

	end

	fclose(fid);

end
