% Copyright © 2017 Universitat Jaume I (UJI) and Tampere University of Technology (TUT)
%
% Permission is hereby granted, free of charge, to any person obtaining a copy of
% this software and associated documentation files (the "Software"), to deal in
% the Software without restriction, including without limitation the rights to
% use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
% of the Software, and to permit persons to whom the Software is furnished to do
% so, subject to the following conditions:
%
% The above copyright notice and this permission notice shall be included in all
% copies or substantial portions of the Software.
%
% THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
% IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
% FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
% AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
% LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
% OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
% SOFTWARE.

function [Macs] = loadDB_mandb_obtainMacs (training, test)

	fid          = fopen (training);
	num_of_lines1 = 0;
	while ~feof(fid)
		num_of_lines1 = num_of_lines1 + sum( fread( fid, 16384, 'char' ) == char(10) );
	end
	fclose(fid);

	fid          = fopen (test);
	num_of_lines2 = 0;
	while ~feof(fid)
		num_of_lines2 = num_of_lines2 + sum( fread( fid, 16384, 'char' ) == char(10) );
	end
	fclose(fid);

	fid          = fopen (training);
	Macs    = {};

	counter = 0;
	for i=1:num_of_lines1

	  fpline =  fgets (fid);
	  if size(fpline,2)>0 && (fpline(1)~='#')
		
		fpelements = strsplit(fpline,';');
		for idx = 1:size(fpelements,2)
		  fpelement = fpelements{idx};
		  if strfind(fpelement,'t=')
		  elseif strfind(fpelement,'pos=')              
		  elseif strfind(fpelement,'degree=')
		  elseif strfind(fpelement,'id=')
		  else
		  
			if ~isfield(Macs,['MAC' (strrep(fpelement(1:17),':',''))])
			counter = counter+1;
			Macs.(['MAC' (strrep(fpelement(1:17),':',''))]) = counter;
			end
			
		  end
		end
	   end
	end
	fclose(fid);

	fid          = fopen (test);
	for i=1:num_of_lines2

	  fpline =  fgets (fid);
	  if size(fpline,2)>0 && (fpline(1)~='#')
		
		fpelements = strsplit(fpline,';');
		for idx = 1:size(fpelements,2)
		  fpelement = fpelements{idx};
		  if strfind(fpelement,'t=')
		  elseif strfind(fpelement,'pos=')              
		  elseif strfind(fpelement,'degree=')
		  elseif strfind(fpelement,'id=')
		  else
			
			if ~isfield(Macs,['MAC' (strrep(fpelement(1:17),':',''))])
			counter = counter+1;
			Macs.(['MAC' (strrep(fpelement(1:17),':',''))]) = counter;
			end
			
		  end
		end
	   end
	end
	fclose(fid);

end
