% Copyright © 2017 Universitat Jaume I (UJI) and Tampere University of Technology (TUT)
%
% Permission is hereby granted, free of charge, to any person obtaining a copy of
% this software and associated documentation files (the "Software"), to deal in
% the Software without restriction, including without limitation the rights to
% use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
% of the Software, and to permit persons to whom the Software is furnished to do
% so, subject to the following conditions:
%
% The above copyright notice and this permission notice shall be included in all
% copies or substantial portions of the Software.
%
% THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
% IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
% FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
% AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
% LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
% OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
% SOFTWARE.

function [ database ] = loadDB_simdb( instance )

	if ~(exist('databases_singlefile/simdb.mat','file'))

	  database0.trainingMacs  = csvread(['../databases/simdb_files/trn' sprintf('%03d',instance) 'rss.csv']);
	  database.trainingLabels = csvread(['../databases/simdb_files/trn' sprintf('%03d',instance) 'crd.csv'  ]);
	  database0.testMacs      = csvread(['../databases/simdb_files/tst' sprintf('%03d',instance) 'rss.csv'  ]);
	  database.testLabels     = csvread(['../databases/simdb_files/tst' sprintf('%03d',instance) 'crd.csv'  ]);
	  
	  % Cols 1-8:  Original 8 APs
	  % Cols 9-16: New APs deployed at the same place than APs 1-8
	  % Cols 17-24: APs 1-8 moved 50 cm to right
	  % Cols 25-32: APs 1-8 moved 50 cm to left
	  % Cols 33-40: APs 1-8 moved 100 cm to right
	  % Cols 41-48: APs 1-8 moved 100 cm to left
	  
	  database.trainingMacs   = database0.trainingMacs(:,1:8); 
	  database.testMacs       = database0.testMacs(:,1:8);
	  
	else
			load('databases_singlefile/simdb.mat','databases');
			database = databases{instance};
	end

end