% Copyright © 2017 Universitat Jaume I (UJI) and Tampere University of Technology (TUT)
%
% Permission is hereby granted, free of charge, to any person obtaining a copy of
% this software and associated documentation files (the "Software"), to deal in
% the Software without restriction, including without limitation the rights to
% use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
% of the Software, and to permit persons to whom the Software is furnished to do
% so, subject to the following conditions:
%
% The above copyright notice and this permission notice shall be included in all
% copies or substantial portions of the Software.
%
% THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
% IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
% FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
% AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
% LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
% OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
% SOFTWARE.

function [repetitions] = setup_getRepetitions (databasename)
% setup_getRepetitions Gets the amount of instances available for the 
% specified database

%   databasename: any of 'simdb','libdb_52','libdb_26','libdb_13_2','libdb_13_5',
%   'mandb','mandb_reduced'

	if strcmp(databasename,'simdb')
		repetitions = 100; 	
	elseif strcmp(databasename,'mandb')
		repetitions = 110;
	elseif strcmp(databasename,'mandb_reduced')
		repetitions = 110;		
	elseif strcmp(databasename,'libdb_52')
		repetitions = 60;
	elseif strcmp(databasename,'libdb_26')
		repetitions = 60;
	elseif strcmp(databasename,'libdb_13_2')
		repetitions = 60;
	elseif strcmp(databasename,'libdb_13_5')
		repetitions = 60;
    else
        repetitions = [];
        warning('Unknown database');
	end
end
